###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################


package DBAccess::DBSchema::Column;
use strict;

use MetadotObject;

use vars qw(@ISA);
@ISA = qw(MetadotObject);

my %CONSTRUCTOR_PROPERTIES = (    
      name              => {value=>undef},
      column_name       => {value=>undef},
      size              => {value=>undef},
      column_size       => {value=>undef},
      label             => {value=>undef},
      nullable          => {value=>undef},
      ordinal_position  => {value=>undef},
      type_name         => {value=>undef},
      sql_data_type     => {value=>undef},
      sql_datetime_sub  => {value=>undef},
      decimal_digits    => {value=>undef},
      num_prec_radix    => {value=>undef},
      buffer_length     => {value=>undef},
      table_name        => {value=>undef},
      column_info       => {value=>undef},
);

sub get_constructor_properties {
    return \%CONSTRUCTOR_PROPERTIES;
}

sub is_nullable {
    my $self = shift;
    return $self->get_nullable();
}

# name is a synonym for column_name
sub get_name {
    my $self = shift;
    return $self->get_column_name(@_);
}

sub set_name {
    my $self = shift;
    return $self->set_column_name(@_);
}

#size is a synonym for column_size
sub get_size {
    my $self = shift;
    $self->get_column_size(@_);
}

sub set_size {
    my $self = shift;
    return $self->set_column_size(@_);
}

sub get_column_name {
    my $self = shift;
    return $self->access_property('column_name', @_);
}

sub set_column_name {
    my $self = shift;
    return $self->mutate_property('column_name', @_);
}

sub get_column_size {
    my $self = shift;
    return $self->access_property('column_size', @_);
}

sub set_column_size {
    my $self = shift;
    return $self->mutate_property('column_size', @_);
}

sub get_label {
    my $self = shift;
    return $self->access_property('label', @_);
}

sub set_label {
    my $self = shift;
    return $self->mutate_property('label', @_);
}

sub get_type {
    my $self = shift;
    return $self->access_property('type', @_);
}

sub set_type {
    my $self = shift;
    return $self->mutate_property('type', @_);
}

sub get_type_name {
    my $self = shift;
    return $self->access_property('type_name', @_);
}

sub set_type_name {
    my $self = shift;
    return $self->mutate_property('type_name', @_);
}

sub get_nullable {
    my $self = shift;
    return $self->access_property('nullable', @_);
}

sub set_nullable {
    my $self = shift;
    return $self->mutate_property('nullable', @_);
}

sub get_decimal_digits {
    my $self = shift;
    return $self->access_property('decimal_digits', @_);
}

sub set_decimal_digits {
    my $self = shift;
    return $self->mutate_property('decimal_digits', @_);
}


1;

