###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################


package DBAccess::DBSchema::Type;
use strict;

use MetadotObject;

use vars qw(@ISA);
@ISA = qw(MetadotObject);

my %CONSTRUCTOR_PROPERTIES = (    
    name => {value=>undef},
);

sub get_constructor_properties {
    return \%CONSTRUCTOR_PROPERTIES;
}

# determines if this type is text
sub is_text {
    my $class = shift;
    my $name = shift;
    my $result;

    if (!defined($name) && ref($class)) {
        $name = $class->get_name();
    }

    $name = uc($name);
    $result ||= ($name =~ /(CHAR|TEXT)/);

    return $result;
}


# determines if this type is a number
sub is_numeric {
    my $class = shift;
    my $name = shift;
    my $result;

    if (!defined($name) && ref($class)) {
        $name = $class->get_name();
    }

    $name = uc($name);
    $result ||= ($name =~ /(INT|NUMBER|FLOAT|LONG|REAL)/);

    return $result;
}


# determines if this type is a date/time
sub is_datetime {
    my $class = shift;
    my $name = shift;
    my $result;

    if (!defined($name) && ref($class)) {
        $name = $class->get_name();
    }

    $name = uc($name);
    $result ||= ($name =~ /(TIME|DATE)/);

    return $result;
}


sub get_name {
    my $self = shift;
    return $self->access_property('name', @_);
}

sub set_name {
    my $self = shift;
    return $self->mutate_property('name', @_);
}




1;
