# $Id: md_poll.pm,v 5.13 2004/02/23 21:17:18 mike Exp $
###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2004
# 
# This file is part of Metadot Portal Server software $Name: Release_6_1_6 $
# 
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
# 
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
# 
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################
package md_poll;
use GizmoTag;
use Metadot qw($PARAMS);
@ISA = ("GizmoTag");
use strict;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new();
    $self->{name} = 'md_poll';
    $self->{version} = '$Revision: 5.13 $';
    $self->{authorname} = 'Mirko Scavazzin';
    $self->{email} = 'mirko@metadot.com';
    $self->{url} = 'http://www.metadot.net/';
    $self->{license} = '';
    $self->{styleclass} = 'tagPollClass';
    $self->{description} = 'display a poll';
    bless ($self, $class);
    return $self;
}

sub md_tag_exec {
  my $self = shift;
  my $myiid = shift;
  my $params = shift;

  my $caller = $params->{'caller'};

  my $output;
  if (defined $caller && $caller->can('show_poll_column')) {
      my $color;
      my $maxitems = 20;
      if (exists $params->{'maxitems'}) {
          $maxitems = $params->{'maxitems'};
      }
      if (($PARAMS->{'template_theme'} eq 'theme1') ||
          ($PARAMS->{'template_theme'} eq 'theme2')) {
          $color = $PARAMS->{'header1_color'};
      }
      
      $output = "<div class='" . $self->get_styleclass() . "'>" .
      $caller->show_poll_column($maxitems, $color) . "</div>";
  }
  return $output;
}

1;

