###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################

# An interface that defines a Metadot::Authenticator class as using an
# external Single-Signon (SSO) mechanism, such as RSA ClearTrust or
# Netegrity SiteMinder
package Metadot::Authenticator::BaseAuthenticator;

use strict;
use MetadotConfig;
use Metadot::Authenticator;
use Metadotclass;

use vars qw(@ISA);
@ISA = qw( Metadot::Authenticator Metadotclass);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self  = $class->SUPER::new();
    return bless($self, $class);
}


sub restore_user {
    my $self = shift;
    my $session = shift;

    my $uid = $session->uid();

    my $user;

    if($uid || $uid == 0) {
        $user = Metadot::UserFactory->get_user( $uid );
    } else {
        $user = Metadot::UserFactory->get_user( MetadotConfig->get_reserved_uid('ANONYMOUS_USER') );	
    }

    return $user;
}



1;
