###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################

# An interface to specify that a gizmo should appear in navigation.
# You should use this if you want a gizmo to appear in site maps and navigation lists

package Metadot::Navigable;

use strict;
use Metadot::PortalFactory;


# returns the level of a page in the site hierarchy, where home page has level 1
sub get_navigation_level {
    my $self = shift;
    return $self->get_distance_from_home() + 1;
}


# returns the navigational distance from home
sub get_distance_from_home {
    my $self = shift;
    my $home_obj = Metadot::PortalFactory->get_home_object();
    
    my $distance = 0;
    my $cursor = $self;
    my %visited = ();       # track visited pages to avoid infinite loops

    while (defined $cursor && !$visited{$cursor->get_id()} && $cursor->get_id() != $home_obj->get_id()) {
        $distance++;
        $visited{$cursor->get_id()} = 1;
        $cursor = $cursor->get_parent();
    }

    return $distance;
}




1;
