###########################################################################
# <LICENSEINFO>
# Copyright (C) Daniel Guermeur - 1999-2001
# Copyright (C) Metadot Corporation - 2001-2004
# 
# This file is part of Metadot Portal Server software $Name: Release_6_1_6 $
# 
# Metadot Portal Server software is free software; you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
# 
# Metadot Portal Server software is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
# 
# You should have received a copy of the GNU General Public License along with
# Metadot Portal Server; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# For more information, please contact info@metadot.com.
#</LICENSEINFO>
############################################################################



package Metadot::RequestContext;
use strict;
use vars qw(@ISA);

use MetadotObject;
use Metadot qw( %REQUEST_VARS );

@ISA = qw(MetadotObject);
sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new(@_);
    return $self;
}

my $CONSTRUCTOR_PROPERTIES = {
    subject         => { value => undef },
    op              => { value => undef },
    user            => { value => undef },
    form            => { value => undef },
    session         => { value => undef },
    locale          => { value => undef },
};

sub get_constructor_properties {
    return $CONSTRUCTOR_PROPERTIES;
}


sub test {
    return "This is the ApplicationContext!";
}

sub get_subject {
    my $self = shift;
    return $self->access_property('subject',@_);
}

sub set_subject {
    my $self = shift;
    return $self->mutate_property('subject',@_);
}

sub get_op {
    my $self = shift;
    return $self->access_property('op',@_);
}

sub set_op {
    my $self = shift;
    return $self->mutate_property('op',@_);
}

sub get_user {
    my $self = shift;
    return $self->access_property('user',@_);
}

sub set_user {
    my $self = shift;
    return $self->mutate_property('user',@_);
}

sub get_form {
    my $self = shift;
    return $self->access_property('form',@_);
}

sub set_form {
    my $self = shift;
    return $self->mutate_property('form',@_);
}

sub get_session {
    my $self = shift;
    return $self->access_property('session',@_);
}

sub set_session {
    my $self = shift;
    return $self->mutate_property('session',@_);
}

sub get_locale {
    my $self = shift;
    return $self->access_property('locale',@_);
}

sub set_locale {
    my $self = shift;
    return $self->mutate_property('locale',@_);
}

sub get_request_vars {
    return \%REQUEST_VARS;
}


1;
