###########################################################################
# <LICENSEINFO>
# Metadot SmartSite Server                                                                      
# Copyright (C) 2001 Metadot Corporation                                                        
#                                                                                               
# For more information go to                                                                    
# http://www.metadot.com                                                                        
# or contact us at info@metadot.com                                                             
#                                                                                               
#</LICENSEINFO>
############################################################################

package Metadot::Skin;

use strict;
use vars qw(@ISA);

use MetadotObject;
@ISA = qw(MetadotObject);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my @args = @_;

    my $self = $class->SUPER::new(@args);

    bless $self, $class;
    return $self;
}


sub get_constructor_properties {
    return {
        id          => {value => ''},
        name        => {value => ''},
        short_name  => {value => ''},
        author      => {value => ''},
        revision    => {value => ''},
        website     => {value => ''},
        description => {value => ''},
        license     => {value => ''},
        read_only   => {value => 'false'},
        based_on    => {value => ''},
        };
}


########################################################
#
# Accessors and mutators
#
########################################################

sub get_id {
    my $self = shift;
    return $self->access_property('id', @_);
}

sub set_id {
    my $self = shift;
    return $self->mutate_property('id', @_);
}

sub get_name {
    my $self = shift;
    return $self->access_property('name', @_);
}

sub set_name {
    my $self = shift;
    return $self->mutate_property('name', @_);
}

sub get_short_name {
    my $self = shift;
    return $self->access_property('short_name', @_);
}

sub set_short_name {
    my $self = shift;
    return $self->mutate_property('short_name', @_);
}

sub get_author {
    my $self = shift;
    return $self->access_property('author', @_);
}

sub set_author {
    my $self = shift;
    return $self->mutate_property('author', @_);
}

sub get_revision {
    my $self = shift;
    return $self->access_property('revision', @_);
}

sub set_revision {
    my $self = shift;
    return $self->mutate_property('revision', @_);
}

sub get_website {
    my $self = shift;
    return $self->access_property('website', @_);
}

sub set_website {
    my $self = shift;
    return $self->mutate_property('website', @_);
}

sub get_description {
    my $self = shift;
    return $self->access_property('description', @_);
}

sub set_description {
    my $self = shift;
    return $self->mutate_property('description', @_);
}

sub get_license {
    my $self = shift;
    return $self->access_property('license', @_);
}

sub set_license {
    my $self = shift;
    return $self->mutate_property('license', @_);
}

sub is_read_only {
    my $self = shift;
    my $read_only_value = $self->get_read_only();
    return ( $read_only_value && lc($read_only_value) ne 'false');
}

sub get_read_only {
    my $self = shift;
    return $self->access_property('read_only', @_);
}

sub set_read_only {
    my $self = shift;
    return $self->mutate_property('read_only', @_);
}

sub get_based_on {
    my $self = shift;
    return $self->access_property('based_on', @_);
}

sub set_based_on {
    my $self = shift;
    return $self->mutate_property('based_on', @_);
}







1;
