package Reader;

use strict;
use Data::Dumper;
use Spreadsheet::ParseExcel;

my $oExcel = new Spreadsheet::ParseExcel;


sub read_data {

	my $class = shift;
	my %args = @_;
	
	my $filename = $args{fileName};
	my $sheetNum = $args{sheetNum} || 0;
	my @rowKeys  = @{$args{rowKeys}};

	my $book = $oExcel->Parse($filename) or die "Cannot find file $filename";
	my $oWkS = $book->{Worksheet}[$sheetNum];
	my @data;

	my($i,$j);
	for ($i = (($oWkS->RowRange())[0])+1; $i<=($oWkS->RowRange())[1]; $i++) {
		my %rowHash;
		for ($j=0; $j<@rowKeys; $j++) {			
			if (defined($oWkS->Cell ($i,$j)) && ($oWkS->Cell ($i,$j)->Value())) {
				$rowHash{$rowKeys[$j]} = uc($oWkS->Cell($i,$j)->Value());
			} else {
				$rowHash{$rowKeys[$j]} = ' ';
			}
		}
		push @data, \%rowHash;
	}
	
	return @data;
}


